# Abe, A better engine

> Abe is your __static websites generator__ with revolutionnary __self-descriptive__ templates

## Getting started

With __npm__ : ```$ npm install -g abe-cli ```

## Abe command line tool

Create website a  ```$ abe create mysite ```
this create your __website structure__ that can be overridden with a json config file

Default project structure :

```
- mysite
 |_ data (contains json data)
 |_ draft (contains file saved as draft)
 |_ site (contains published files, this is your static website)
 |_ structure (add as many folders and subfolders to create your website structure)
 |_ templates (put your templates here)
```

Launch abe engine 

```$ cd mysite ```

```$ abe serve ```

OR

start server with nodemon (dev)

```$ abe servedev ```

OR

start server with pm2 ([pm2](https://www.npmjs.com/package/pm2) must be installed globally)

```$ abe servepm2 ```


## Options

```
Usage: abe [commande] {OPTIONS}

Standard Options:

   --port, -p <port> 	Use a specific port
   
   --interactive , -i   Open abe inside browser (use with serve command)

```

## Usage

```
Usage: abe [commande] {OPTIONS}

Standard Options:

--version, -V 	Output the version number

   --help, -h 	Show this message

```

## Creating abe template
List of self-descriptive Abe tag

- tag __text__ :

```
{{abe type='text' key='text_key' desc='give some tips' tab='default'}}
```
- tag __link__

```
<a href="{{abe type='link' key='link_key' desc='give some tips' title='html title' tab='default'}}">
	my link
</a>
```
- tag __image__

```
<img src="{{abe type='image' key='image_key' desc='give some tips' width='100' height='100' alt='html alt' tab='default'}}" />
```
- tag __textarea__

```
{{abe type='textarea' key='textarea_key' desc='give some tips' tab='default'}}
```
- tag __file__

```
{{abe type='file' filetype='file_type' key='file_key' desc='give some tips' tab='default'}}
```
- tag __rich__

```
{{abe type='rich' key='rich_key' desc='give some tips' tab='default'}}
```
- tag __data__

```
{{abe type='data' key='data_key' desc='give some tips' source='select * from article' max-length='5' display='json_field_to_show' editable="false" tab='default'}}
```
Parameters:
- __display__: if source is type of json, use display to show inside the input type select when on the admin editor
- __editable__: set to false if the field isn't editable, so data will be automatically used without user interaction
- __source__: data to use, with multiple value possible (see below)

Sql like select folder/abe tag
```javascript
source='select * from article'
```
```javascript
source='select title from article where title="test" LIMIT 2'
```
```javascript
source='select title from article where title="test" order by date DESC'
```

Inline json
```javascript
source='["green", "blue", "red"]'
```

Load local .json file into reference folder
```javascript
source='path/to/file/into/reference/folder'
```

Load from webservice
```javascript
source='http://url.of/the/webservice'
```

How to use source into your html file

```html
<div>
{{#each data_key}}
	{{this.title}}
{{/each}}
</div>
```

- loop each (create content bloc) 

```
{{#each key_name}}
​	{{abe type='text' key='key_name.text_key' desc='give some tips' tab='default'}}
{{/each}}
```

More detailled documentation comming soon

## Adding a template and assets (css / js / images ...)

to add a template just paste it inside of templates directory

```
- mysite
 |_ templates 
	|_ template.html
	|_ template_files
```

Assets must be in the same folder of your project and have the same name followed by `_files`


More detailled documentation comming soon

## Abe command to build all pages

coming soon

## Support / Contributing

coming soon
